#include "callfunc.h"

#include <assert.h>

long cinvoke_call_func(generic_func_ptr_t func_ptr, char *stack, unsigned long stack_size)
{
    long result;
    
    long stack_dword_count = stack_size/4;
    assert(stack_dword_count*4 == stack_size);
    
    __asm__ __volatile__(
        "movl %2, %%ecx\n"
        "movl %1, %%esi\n"
        "subl %3, %%esp\n"
        "movl %%esp, %%edi\n"
        "cld\n"
        "rep; movsl\n"
        "call *%4\n"
        "addl %3, %%esp\n"
        : "=a"(result)
        : "m" (stack),
          "m" (stack_dword_count),
          "m" (stack_size),
          "r" (func_ptr)
        : "%edi", "%esi", "%ecx"
    );
    return result;
}
