/* This file is internal, and only exposed for technical reasons. All
 * definitions here are private. */

#ifndef __cinvoke_server_type_h_
#define __cinvoke_server_type_h_

#include "c.h"

typedef struct {
    cinvoke_bool_t should_exit;
    long result;
} cinvoke_server_exit_status_t;

#define CINVOKE_EVENT_LIST_NODE_SIZE(buffer_size)        (sizeof(struct cinvoke_event_list_node) - 1 + (buffer_size))

struct cinvoke_event_list_node {
    struct cinvoke_event_list_node *next;
    
    unsigned long buffer_size;
    /* Dynamic structure size. Must use [1] for silly compilers that dislike [0]: */
    char buffer[1];
};

typedef struct {
    struct cinvoke_event_list_node *first;
    struct cinvoke_event_list_node **last_ptr;
} cinvoke_event_queue_t;

struct cinvoke_server {
    int in_fd;
    int out_fd;
    char *call_buffer;
    unsigned long call_buffer_offset;
    unsigned long nest_level;
    
    unsigned long out_fd_ref_count;
    cinvoke_event_queue_t event_queue;

    /* These are not really server-global, but they are call-bound and
     * its not convinient to pass them around in the stack all the
     * time... */
    cinvoke_server_exit_status_t exit_status;
};

#endif
