from DataTypes.FuncCache import func_cache
from DataTypes.MStr import mstr
from DataTypes import CDataTypes

class FunctionPointer(CDataTypes.SymbolPointer):
    return_node_type = None
    
    def __init__(self, *args, **kw):
        self.client = kw.pop('client')
        self.with_response = kw.pop('with_response', True)
        super(FunctionPointer, self).__init__(exec_info=self.client.exec_info, *args, **kw)

    def _repr_fields(self):
        repr_fields = super(FunctionPointer, self)._repr_fields()
        return repr_fields + ['with_response=%r' % (self.with_response,)]
    
    def __call__(self, *args):
        result = self.client._call(self.value, args, self.with_response)
        if result is not None:
            return self.return_node_type.from_value(mstr, result)

@func_cache
def func_ptr_type(return_type=CDataTypes.Long):
    class TempFunctionPointer(FunctionPointer):
        return_node_type = return_type
    TempFunctionPointer.__name__ = 'FuncPtr_%s' % (return_type.__name__,)
    return TempFunctionPointer
