def proxy_attr_property(name):
    def get_proxy_attr(self):
        return getattr(self.seq, name)
    return property(get_proxy_attr)

class MBufProxy(object):
    """A Sequence Proxy that supports the extended sequence protocol used by
    CInvoke.

    i.e: Except for __len__ and item handling, it also forwards offset and
    address_space requests."""
    def __init__(self, seq):
        self.seq = seq
    __getitem__ = proxy_attr_property('__getitem__')
    __setitem__ = proxy_attr_property('__setitem__')
    __delitem__ = proxy_attr_property('__delitem__')
    __len__ = proxy_attr_property('__len__')
    offset = proxy_attr_property('offset')
    address_space = proxy_attr_property('address_space')
