from NamedValueNode import NamedValueNode
from Pointers import Pointer
from DataTypes.FuncCache import func_cache

class SymbolPointer(NamedValueNode):
    node_type = Pointer
    
    def __init__(self, *args, **kw):
        self.exec_info = kw.pop('exec_info')
        super(SymbolPointer, self).__init__(*args, **kw)

    def _repr_fields(self):
        repr_fields = super(SymbolPointer, self)._repr_fields()
        return ['exec_info=%r' % (self.exec_info,)] + repr_fields

    def _value_name_of_value(self, value):
        return self.exec_info.name_of_symbol_offset.get(value, "UnknownSymbol_%d" % (value,))
    
    def _value_of_value_name(self, value_name):
        symbol_area = self.exec_info.symbol_area(value_name)
        if symbol_area is None:
            raise ValueError("%r does not contains the symbol name" % (self.exec_info,), value_name)
        offset, size = symbol_area
        return offset

@func_cache
def symbol_ptr_type(ptd_node_type):
    class TempSymbolPointer(SymbolPointer):
        node_type = ptr_type(ptd_node_type)
    TempSymbolPointer.__name__ = 'SymbolPointerTo%s' % (ptd_node_type.__name__,)
    return TempSymbolPointer
