class Error(Exception): pass

# The following code is mind-boggling, Enjoy!!

def _decorator(extract_func, decorator_func):
    """The decorators' decorator
    """
    def new_decorator(*args, **kw):
        new_func = decorator_func(*args, **kw)
        func = extract_func(*args, **kw)
        # If decorator returned already decorated function, no need to
        # re-decorate it.
        for attrname in ['__origfunc__', '__sigfunc__']:
            if not hasattr(new_func, attrname) and new_func is not func:
                setattr(new_func, attrname, func)
        for attrname in [
            '__module__',
            '__doc__',
            '__name__',
        ]:
            if hasattr(func, attrname):
                setattr(new_func, attrname, getattr(func, attrname))
        return new_func
    return new_decorator

def decorator(decorator_func):
    def extract_func(func):
        return func
    return _decorator(extract_func, decorator_func)
# Decorate the decorators' decorator :-)
decorator = decorator(decorator)

@decorator
def method_decorator(decorator_method):
    def extract_func(self, func):
        return func
    return _decorator(extract_func, decorator_method)

# Mind boggling part completed...

def _walk(attrname, func, visited_ids):
    if id(func) in visited_ids:
        raise Error("Decorated function loop!")
    visited_ids.add(id(func))
    if hasattr(func, attrname):
        return _walk(attrname, getattr(func, attrname), visited_ids)
    return func

def origfunc(func):
    return _walk('__origfunc__', func, set())

def sigfunc(func):
    return _walk('__sigfunc__', func, set())
