def sum_dicts(*dicts, **kw):
    allow_override = kw.pop('allow_override', True)
    return _sum_dicts(allow_override, dicts, **kw)

def _sum_dicts(allow_override, dicts):
    dict_sum = dicts[0].copy()
    for cur_dict in dicts[1:]:
        dict_sum_length = len(dict_sum)
        dict_sum.update(cur_dict)
        if (not allow_override and
            (len(dict_sum) - dict_sum_length) < len(cur_dict)):
            raise ValueError("Overriding dict values disallowed")
    return dict_sum
