from DataTypes.Decorators import decorator

class FuncCache(object):
    def __init__(self, func):
        self._func = func
        self.flush()
    def __repr__(self):
        return '<cached function %s>' % (self._func.__name__,)
    def __call__(self, *args, **kw):
        key = (args, tuple(kw.items()))
        try:
            hash(key)
        except TypeError:
            from cPickle import dumps
            key = dumps(key)
        if key not in self._cache:
            self._cache[key] = self._func(*args, **kw)
        return self._cache[key]
    def flush(self):
        '''
        Use flush when you want the function to run again despite previous caching
        '''
        self._cache = {}

@decorator
def func_cache(x):
    return FuncCache(x)
