class ItemHandling(object):
    def __length(self):
        try:
            return len(self)
        except TypeError:
            return None
    
    def __getitem__(self, index):
        get_slice = getattr(self, '_get_slice', None)
        if get_slice is None:
            raise TypeError("Unsubscriptable object")
        if isinstance(index, slice):
            return self._get_slice(index)
        value, = self._get_slice(single_index_slice(index, self.__length()))
        return value

    def __setitem__(self, index, value):
        set_slice = getattr(self, '_set_slice', None)
        if set_slice is None:
            raise TypeError("Object does not support item assignment")
        if isinstance(index, slice):
            set_slice(index, value)
        else:
            set_slice(single_index_slice(index, self.__length()), value)

    def __delitem__(self, index):
        del_slice = getattr(self, '_del_slice', None)
        if del_slice is None:
            raise TypeError("Object does not support item deletion")
        if isinstance(index, slice):
            del_slice(index)
        else:
            del_slice(single_index_slice(index, self.__length()), value)
