import sys
import time
from copy import copy

def chunks(seq, size):
    for i in xrange(0, len(seq), size):
        yield seq[i:i+size]

def put_in_range(x, length=None):
    x = max(x, 0)
    if length is not None:
        x = min(x, length-1)
    return x

def normalize_index(x, length=None, check_range=True, fix_range=True):
    if x < 0:
        if length is None:
            raise TypeError("Cannot use negative index on unsized sequence")
        x += length
    if x < 0 and check_range:
        raise IndexError("Negative index out of bounds")
    if check_range and length is not None and x >= length:
        raise IndexError("Index out of bounds")
    if fix_range:
        x = put_in_range(x, length)
    return x
