import os
from DataTypes import Decorators

class Error(Exception): pass

@Decorators.decorator
def mtime_cache(func):
    cache = {}
    def new_func(filename):
        if not os.path.exists(filename):
            raise Error("File does not exist", filename)
        mtime = os.stat(filename).st_mtime
        if filename in cache:
            file_mtime, result = cache[filename]
            if file_mtime == mtime:
                return result
        result = func(filename)
        cache[filename] = (mtime, result)
        return result
    return new_func

